//////////////// API FUNCTION CALLS ////////////////

//////////////// API: Helper Functions  ////////////////

var htmlResponseMessage = "#apiResponseMessage";//////////
var htmlResponseId = "#apiResponseId";

window.onload = function () {
	$("#apiUrl").val(location.origin);
};

function logError(errorCode, errorMessage, id) {
	$(htmlResponseMessage).html("logError(" + id + "): [" + errorCode + "]: " + errorMessage);
}

function logResponse(data, id) {
	$(htmlResponseMessage).html("logResponse(" + id + "):\n" + JSON.stringify(data, null, "\t"));
}

function logSuccess(id) {
	$(htmlResponseMessage).html("logSuccess(" + id + "): Succeeded.");
}

//////////////// API: Verification Functions  ////////////////

function apiLogin() {
	devicewise.login($("#apiUrl").val(), $("#apiUser").val(), $("#apiPassword").val(),
		function () {
			$("#apiLoginState").html("Logged in");
			$('#apiActions button').removeAttr('disabled');
			$("#apiLogin").attr('disabled', true);
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiLoginState");
		}
	);
};

function apiLogout() {
	devicewise.logout();
	$("#apiLoginState").html("Logged out");
	$('#apiActions button').removeAttr('disabled');
}

/////////////////////////////////////////////////////
function subtriggerVarAdd() {
	var num = $('.clonedInput').length;
	var newNum = new Number(num + 1);
	var count = new Number($("#apiSubtriggerFireCount").text());

	if (count == 0) {
		$("#apiSubtriggerFireCount").html(1);
		$("#apiSubtriggerFireVarInput1").html("<div id=\"apiSubtriggerFireVarForm1\"> <p> <label>Variable:</label> <input id=\"apiSubtriggerFireVarName\" value=\"int4\"></input> <br> <label>Data to write (comma delimited for arrays):</label> <input id=\"apiSubtriggerFireVarData\" value=\"1\"></input> <br> </p> </div>");
		return;
	}

	$("#apiSubtriggerFireCount").html(newNum);
	var newElem = $('#apiSubtriggerFireVarInput' + num).clone().attr('id', 'apiSubtriggerFireVarInput' + newNum);
	newElem.children(':first').attr('id', 'apiSubtriggerFireVarForm' + newNum);
	$('#apiSubtriggerFireVarInput' + num).after(newElem);
};

function subtriggerVarRemove() {
	var count = new Number($("#apiSubtriggerFireCount").text());
	var num = $('.clonedInput').length;
	if (count <= 0) return;
	if (count == 1) {
		$("#apiSubtriggerFireVarInput" + num).html("");
		$("#apiSubtriggerFireCount").html(num - 1);
		return;
	}
	$('#apiSubtriggerFireVarInput' + num).remove();
	$("#apiSubtriggerFireCount").html(num - 1);
}

function apiSubtriggerFireNow() {
	var projectName = $("#apiSubtriggerFireProject").val();
	var triggerName = $("#apiSubtriggerFireTrigger").val();
	var reportingEnabled = $("#apiSubtriggerFireReporting").val();
	var variableCount = new Number($("#apiSubtriggerFireCount").text());
	var variables = [];

	for (i = 0; i < variableCount; i++) {
		var form = $("#apiSubtriggerFireVarInput" + (i + 1))
		var varName = form.find("#apiSubtriggerFireVarName").val();
		var varData = form.find("#apiSubtriggerFireVarData").val();
		var obj = {};
		if (varData.indexOf(",") > 0) {
			varData = form.find("#apiSubtriggerFireVarData").val().split(',');
		}
		obj[varName] = varData;
		variables.push(obj);
	}

	if (reportingEnabled == "on") {
		reportingEnabled = "true";
	} else reportingEnabled = "false";

	devicewise.subtriggerFire(projectName, triggerName, reportingEnabled, variables,
		function (data) {
			logResponse(data, "#subtriggerFire");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#subtriggerFire");
		});

}
/////////////////////////////////////////////////////

//////////////// API: Empty Response Functions  ////////////////

function apiTriggerStart() {
	devicewise.triggerStart($("#apiTriggerStartProject").val(), $("#apiTriggerStartTrigger").val(),
		function () {
			logSuccess("#apiTriggerStartResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiTriggerStartResponse");
		});
}

function apiTriggerFire() {
	devicewise.triggerFire($("#apiTriggerFireProject").val(), $("#apiTriggerFireTrigger").val(),
		function () {
			logSuccess("#apiTriggerFireResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiTriggerFireResponse");
		});
}

function apiTriggerStop() {
	devicewise.triggerStop($("#apiTriggerStopProject").val(), $("#apiTriggerStopTrigger").val(),
		function () {
			logSuccess("#apiTriggerStopResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiTriggerStopResponse");
		});
}

function apiProjectStart() {
	devicewise.projectStart($("#apiProjectStartProject").val(),
		function () {
			logSuccess("#apiProjectStartResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiProjectStartResponse");
		});
}

function apiProjectStop() {
	devicewise.projectStop($("#apiProjectStopProject").val(),
		function () {
			logSuccess("#apiProjectStopResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiProjectStopResponse");
		});
}

function apiDeviceStart() {
	devicewise.deviceStart($("#apiDeviceStartDevice").val(),
		function () {
			logSuccess("#apiDeviceStartResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiDeviceStartResponse")
		});
}

function apiDeviceStop() {
	devicewise.deviceStop($("#apiDeviceStopDevice").val(),
		function () {
			logSuccess("#apiDeviceStopResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiDeviceStopResponse");
		});
}

function apiWriteVar() {
	var data = $("#apiWriteData").val();
	if ($("#apiWriteData").val().indexOf(",") > 0) {
		data = $("#apiWriteData").val().split(',');
	}
	devicewise.write(
		$("#apiWriteDevice").val(),
		$("#apiWriteVariable").val(),
		$("#apiWriteType").val(),
		$("#apiWriteCount").val(),
		$("#apiWriteLength").val(),
		data,
		function () {
			logSuccess("#apiWriteResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiWriteResponse");
		}
	);
}

//////////////// API: Response Returned Functions with Extra Processing Functions  ////////////////

var variableSubscriptions = [];
var variableMessages = 0;
function apiVariableSubscribe() {
	devicewise.subscribe(
		$("#apiSubscribeDevice").val(),
		$("#apiSubscribeVariable").val(),
		$("#apiSubscribeRate").val(),
		$("#apiSubscribeType").val(),
		$("#apiSubscribeCount").val(),
		$("#apiSubscribeLength").val(),
		function (id) {
			logSuccess("#apiVariableSubscribeResponse[" + id + "]:");
			variableSubscriptions.push(id);
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiVariableSubscribeResponse");
		},
		function (id, data) {
			logResponse(data, "#apiVariableSubscriptionsPost[" + id + "]:");
			if (variableMessages > 5) {
				$("#apiVariableSubscriptionsPost span").last().remove();
			} else {
				variableMessages++;
			}
			$("#apiVariableSubscriptionsPost").prepend("<span> [" + id + "]: " + JSON.stringify(data, null, "\t") + "</br></span>");
		}
	);
}

function apiVariableUnsubscribe() {
	var id = $("#apiVariableUnsubscribe").val();
	devicewise.unsubscribe(id,
		function () {
			logSuccess("#apiVariableUnsubscribe");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiVariableUnsubscribe");
		});

	for (var i = 0; i < variableSubscriptions.length; i++) {
		if (variableSubscriptions[i] == id) {
			variableSubscriptions.splice(i, 1);
		}
	}
}

function apiVariableUnsubscribeAll() {
	for (var i = 0; i < variableSubscriptions.length; i++) {
		devicewise.unsubscribe(variableSubscriptions[i],
			function () {
				logSuccess("#apiVariableUnsubscribeAll");
			},
			function (errorCode, errorMessage) {
				logError(errorCode, errorMessage, "#apiVariableUnsubscribeAll");
			});
	}
}

var channelSubscriptions = [];
var channelSubscriptionMessages = 0;
function apiChannelSubscribe() {
	devicewise.channelSubscribe($("#apiChannelSubscribe").val(),
		function (id) {
			logSuccess("#apiChannelSubscribeResponse[" + id + "]:");
			channelSubscriptions.push(id);
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiChannelSubscribeResponse");
		},
		function (data) {
			logResponse(data, "#apiChannelSubscribePost");
			if (channelSubscriptionMessages > 5) {
				$("#apiChannelSubscribePost span").last().remove();
			} else {
				channelSubscriptionMessages++;
			}
			$("#apiChannelSubscribePost").prepend("<span>" + JSON.stringify(data, null, "\t") + "</br></span>");
		});
}

function apiChannelUnsubscribe() {
	var id = $("#apiChannelUnsubscribe").val();
	devicewise.channelUnsubscribe(id,
		function () {
			logSuccess("#apiChannelUnsubscribe");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiChannelUnsubscribe");
		});

	for (var i = 0; i < channelSubscriptions.length; i++) {
		if (channelSubscriptions[i] == id) {
			channelSubscriptions.splice(i, 1);
		}
	}
}

function apiChannelUnsubscribeAll() {
	for (var i = 0; i < channelSubscriptions.length; i++) {
		devicewise.channelUnsubscribe(channelSubscriptions[i],
			function () {
				logSuccess("#apiChannelUnsubscribeAll");
			},
			function (errorCode, errorMessage) {
				logError(errorCode, errorMessage, "#apiChannelUnsubscribeAll");
			});
	}
}

//////////////// API: Response Returned Functions  ////////////////

function apiReadVar() {
	devicewise.read(
		$("#apiReadDevice").val(),
		$("#apiReadVariable").val(),
		$("#apiReadType").val(),
		$("#apiReadCount").val(),
		$("#apiReadLength").val(),
		function (data) {
			logResponse(data, "#apiReadResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiReadResponse");
		}
	);
}

function apiDeviceInfo() {
	devicewise.deviceInfo($("#apiDeviceInfoDevice").val(),
		function (data) {
			logResponse(data, "#apiDeviceInfoResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiDeviceInfoResponse");
		});
}

function apiDeviceList() {
	devicewise.deviceList(
		function (data) {
			logResponse(data, "#apiDeviceList");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiDeviceList");
		}
	);
}

function apiDeviceTypeEnum() {
	devicewise.deviceDataTypeEnum(
		function (data) {
			logResponse(data, "#apiDeviceTypeEnum");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiDeviceTypeEnum");
		}
	);
}

function apiTriggerList() {
	devicewise.triggerList(
		$("#apiTriggerListProject").val(),
		function (data) {
			logResponse(data, "#apiTriggerList");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiTriggerList");
		}
	);
}

function apiProjectList() {
	devicewise.projectList(
		function (data) {
			logResponse(data, "#apiProjectList");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiProjectList");
		}
	);
}

function apiNetworkPing() {
	devicewise.networkPing($("#apiNetworkPingIP").val(), parseInt($("#apiNetworkPingNumPings").val()),
		function (data) {
			logResponse(data, "#apiNetworkPingResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiNetworkPingResponse");
		});
}

function apiReferenceList() {
	devicewise.referenceList($("#apiReferenceListSourceType").val(), $("#apiReferenceListSource").val(), $("#apiReferenceListOptions").val(),
		function (data) {
			logResponse(data, "#apiReferenceListResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiReferenceListResponse")
		});
}

function apiSQLiteExec() {
	console.log($("#apiSQLiteExecQuery").val());
	devicewise.SQLiteExec($("#apiSQLiteExecQuery").val(),
		function (data) {
			logResponse(data, "#apiSQLiteExecResponse");
		},
		function (errorCode, errorMessage) {
			logError(errorCode, errorMessage, "#apiSQLiteExecResponse");
		});
}
